package TableNested;

import java.util.ArrayList;

/**
 * All you need to do for this microlab is take the Table and Entry from the last one and make Entry a nested class.
 * Think about how nested classes should work with generics.
 */
public class TableNested<K, V> {
    private ArrayList<Entry> entries;

    public TableNested() {
        entries = new ArrayList<Entry>();
    }

    public void put(K key, V value) {
        if (!contains(key)) entries.add(new Entry(key, value));
        else {
            remove(key);
            entries.add(new Entry(key, value));
        }
    }
    public V get(K key) {
        for (Entry e : entries) {
            if (e.getKey().equals(key)) { return (V) e.getValue(); }
        }
        return null;
    }
    public void remove(K key) {
        for (int i = 0; i < entries.size(); i++) {
            if (entries.get(i).getKey().equals(key)) { entries.remove(i); }
        }
    }
    private boolean contains(K key) {
        for (Entry e : entries) {
            if (e.getKey().equals(key)) return true;
        }
        return false;
    }
    private class Entry {
        private K key;
        private V value;

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

    }

}
